Update ha_entrypoint.sh

This commit is contained in:
Alexandre
2025-07-19 23:09:38 +02:00
committed by GitHub
parent 9f285025c0
commit c2909097c0

View File

@@ -7,50 +7,96 @@ echo "Starting..."
# Starting scripts # # Starting scripts #
#################### ####################
# Loop through /etc/cont-init.d/*
for SCRIPTS in /etc/cont-init.d/*; do for SCRIPTS in /etc/cont-init.d/*; do
[ -e "$SCRIPTS" ] || continue [ -e "$SCRIPTS" ] || continue
echo "$SCRIPTS: executing" echo "$SCRIPTS: executing"
# Check if run as root # Check if run as root
if [ "$(id -u)" -eq 0 ]; then if [ "$(id -u)" -eq 0 ]; then
chown "$(id -u)":"$(id -g)" "$SCRIPTS" chown "$(id -u)":"$(id -g)" "$SCRIPTS"
chmod a+x "$SCRIPTS" chmod a+x "$SCRIPTS"
else else
echo -e "\e[38;5;214m$(date) WARNING: Script executed with user $(id -u):$(id -g), things can break and chown won't work\e[0m" echo -e "\e[38;5;214m$(date) WARNING: Script executed with user $(id -u):$(id -g), things can break and chown won't work\e[0m"
# Disable chown and chmod in scripts # Disable chown and chmod in scripts
sed -i "s/^chown /true # chown /g" "$SCRIPTS" sed -i "s/^chown /true # chown /g" "$SCRIPTS"
sed -i "s/ chown / true # chown /g" "$SCRIPTS" sed -i "s/ chown / true # chown /g" "$SCRIPTS"
sed -i "s/^chmod /true # chmod /g" "$SCRIPTS" sed -i "s/^chmod /true # chmod /g" "$SCRIPTS"
sed -i "s/ chmod / true # chmod /g" "$SCRIPTS" sed -i "s/ chmod / true # chmod /g" "$SCRIPTS"
fi fi
# Get current shebang, if not available use another # Get current shebang, if not available use another
currentshebang="$(sed -n '1{s/^#![[:blank:]]*//p;q}' "$SCRIPTS")" currentshebang="$(sed -n '1{s/^#![[:blank:]]*//p;q}' "$SCRIPTS")"
if [ ! -f "${currentshebang%% *}" ]; then if [ ! -f "${currentshebang%% *}" ]; then
for shebang in "/command/with-contenv bashio" "/usr/bin/with-contenv bashio" "/usr/bin/env bashio" "/usr/bin/bashio" "/usr/bin/bash" "/usr/bin/sh" "/bin/bash" "/bin/sh"; do for shebang in "/command/with-contenv bashio" "/usr/bin/with-contenv bashio" "/usr/bin/env bashio" "/usr/bin/bashio" "/usr/bin/bash" "/usr/bin/sh" "/bin/bash" "/bin/sh"; do
command_path="${shebang%% *}" command_path="${shebang%% *}"
if [ -x "$command_path" ] && "$command_path" echo "yes" >/dev/null 2>&1; then if [ -x "$command_path" ] && "$command_path" echo "yes" >/dev/null 2>&1; then
echo "Valid shebang: $shebang" echo "Valid shebang: $shebang"
break break
fi fi
done done
sed -i "s|$currentshebang|$shebang|g" "$SCRIPTS" sed -i "s|$currentshebang|$shebang|g" "$SCRIPTS"
fi fi
# Use source to share env variables when requested # Use source to share env variables when requested
if [ "${ha_entry_source:-null}" = true ] && command -v "source" &>/dev/null; then if [ "${ha_entry_source:-null}" = true ] && command -v "source" &>/dev/null; then
sed -i "s/(.*\s|^)exit ([0-9]+)/\1 return \2 || exit \2/g" "$SCRIPTS" sed -i "s/(.*\s|^)exit \([0-9]\+\)/ \1 return \2 || exit \2/g" "$SCRIPTS"
sed -i "s/bashio::exit.nok/return 1/g" "$SCRIPTS" sed -i "s/bashio::exit.nok/return 1/g" "$SCRIPTS"
sed -i "s/bashio::exit.ok/return 0/g" "$SCRIPTS" sed -i "s/bashio::exit.ok/return 0/g" "$SCRIPTS"
# shellcheck disable=SC1090 # shellcheck disable=SC1090
source "$SCRIPTS" || echo -e "\033[0;31mError\033[0m : $SCRIPTS exiting $?" source "$SCRIPTS" || echo -e "\033[0;31mError\033[0m : $SCRIPTS exiting $?"
else else
"$SCRIPTS" || echo -e "\033[0;31mError\033[0m : $SCRIPTS exiting $?" "$SCRIPTS" || echo -e "\033[0;31mError\033[0m : $SCRIPTS exiting $?"
fi fi
# Cleanup # Cleanup
rm "$SCRIPTS" rm "$SCRIPTS"
done
# Loop through /etc/services.d/*/run
[[ -d /etc/services.d ]] && for SERVICE in /etc/services.d/*/run; do
[ -e "$SERVICE" ] || continue
echo "$SERVICE: executing"
# Check if run as root
if [ "$(id -u)" -eq 0 ]; then
chown "$(id -u)":"$(id -g)" "$SERVICE"
chmod a+x "$SERVICE"
else
echo -e "\e[38;5;214m$(date) WARNING: Script executed with user $(id -u):$(id -g), things can break and chown won't work\e[0m"
# Disable chown and chmod in scripts
sed -i "s/^chown /true # chown /g" "$SERVICE"
sed -i "s/ chown / true # chown /g" "$SERVICE"
sed -i "s/^chmod /true # chmod /g" "$SERVICE"
sed -i "s/ chmod / true # chmod /g" "$SERVICE"
fi
# Get current shebang, if not available use another
currentshebang="$(sed -n '1{s/^#![[:blank:]]*//p;q}' "$SERVICE")"
if [ ! -f "${currentshebang%% *}" ]; then
for shebang in "/command/with-contenv bashio" "/usr/bin/with-contenv bashio" "/usr/bin/env bashio" "/usr/bin/bashio" "/usr/bin/bash" "/usr/bin/sh" "/bin/bash" "/bin/sh"; do
command_path="${shebang%% *}"
if [ -x "$command_path" ] && "$command_path" echo "yes" >/dev/null 2>&1; then
echo "Valid shebang: $shebang"
break
fi
done
sed -i "s|$currentshebang|$shebang|g" "$SERVICE"
fi
# Use source to share env variables when requested
if [ "${ha_entry_source:-null}" = true ] && command -v "source" &>/dev/null; then
sed -i "s/(.*\s|^)exit \([0-9]\+\)/ \1 return \2 || exit \2/g" "$SERVICE"
sed -i "s/bashio::exit.nok/return 1/g" "$SERVICE"
sed -i "s/bashio::exit.ok/return 0/g" "$SERVICE"
# shellcheck disable=SC1090
source "$SERVICE" || echo -e "\033[0;31mError\033[0m : $SERVICE exiting $?"
else
"$SERVICE" || echo -e "\033[0;31mError\033[0m : $SERVICE exiting $?"
fi
# Cleanup
rm "$SERVICE"
done done
###################### ######################
@@ -59,41 +105,41 @@ done
# If PID 1, keep alive and manage sigterm # If PID 1, keep alive and manage sigterm
if [ "$$" -eq 1 ]; then if [ "$$" -eq 1 ]; then
echo " " echo " "
echo -e "\033[0;32mEverything started!\033[0m" echo -e "\033[0;32mEverything started!\033[0m"
terminate() { terminate() {
echo "Termination signal received, forwarding to subprocesses..." echo "Termination signal received, forwarding to subprocesses..."
# Terminate all subprocesses # Terminate all subprocesses
if command -v pgrep &>/dev/null; then if command -v pgrep &>/dev/null; then
for pid in $(pgrep -P $$); do for pid in $(pgrep -P $$); do
echo "Terminating child PID $pid" echo "Terminating child PID $pid"
kill -TERM "$pid" 2>/dev/null || echo "Failed to terminate PID $pid" kill -TERM "$pid" 2>/dev/null || echo "Failed to terminate PID $pid"
done done
else else
# Fallback to iterating through /proc if pgrep is not available # Fallback to iterating through /proc if pgrep is not available
for pid in /proc/[0-9]*/; do for pid in /proc/[0-9]*/; do
pid=${pid#/proc/} pid=${pid#/proc/}
pid=${pid%/} pid=${pid%/}
if [[ "$pid" -ne 1 ]] && grep -q "^PPid:\s*$$" "/proc/$pid/status" 2>/dev/null; then if [[ "$pid" -ne 1 ]] && grep -q "^PPid:\s*$$" "/proc/$pid/status" 2>/dev/null; then
echo "Terminating child PID $pid" echo "Terminating child PID $pid"
kill -TERM "$pid" 2>/dev/null || echo "Failed to terminate PID $pid" kill -TERM "$pid" 2>/dev/null || echo "Failed to terminate PID $pid"
fi fi
done done
fi fi
wait wait
echo "All subprocesses terminated. Exiting." echo "All subprocesses terminated. Exiting."
exit 0 exit 0
} }
trap terminate SIGTERM SIGINT trap terminate SIGTERM SIGINT
while :; do while :; do
sleep infinity & sleep infinity &
wait $! wait $!
done done
else else
echo " " echo " "
echo -e "\033[0;32mStarting the upstream container\033[0m" echo -e "\033[0;32mStarting the upstream container\033[0m"
echo " " echo " "
# Launch lsio mods # Launch lsio mods
if [ -f /docker-mods ]; then exec /docker-mods; fi if [ -f /docker-mods ]; then exec /docker-mods; fi
fi fi